searchNodes=[{"doc":"An HTTP client with a focus on performance, built on top of Mint and NimblePool. Usage In order to use Finch, you must start it and provide a :name. Often in your supervision tree: children = [ {Finch, name: MyFinch} ] Or, in rare cases, dynamically: Finch.start_link(name: MyFinch) Once you have started Finch, you can use the client you have started, by passing the name of your client as the first argument of Finch.request/3,4,5,6: Finch.request(MyFinch, :get, &quot;https://hex.pm&quot;) When using HTTP/1, Finch will parse the passed in URL into a {scheme, host, port} tuple, and maintain one or more connection pools for each {scheme, host, port} you interact with. You can also configure a pool size and count to be used for specific URLs that are known before starting Finch. The passed URLs will be parsed into {scheme, host, port}, and the corresponding pools will be started. See Finch.start_link/1 for configuration options. children = [ {Finch, name: MyConfiguredFinch, pools: %{ :default =&gt; [size: 10], &quot;https://hex.pm&quot; =&gt; [size: 32, count: 8] }} ] Pools will be started for each configured {scheme, host, port} when Finch is started. For any unconfigured {scheme, host, port}, the pool will be started the first time it is requested. Note pools are not automatically terminated if they are unused, so Finch is best suited when you are requesting a known list of static hosts. Telemetry Finch uses Telemetry to provide instrumentation. See the Finch.Telemetry module for details on specific events.","ref":"Finch.html","title":"Finch","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Finch.html#child_spec/1","title":"Finch.child_spec/1","type":"function"},{"doc":"Sends an HTTP request and returns the response. Options: :pool_timeout - This timeout is applied when we check out a connection from the pool. Default value is 5_000. :receive_timeout - The maximum time to wait for a response before returning an error. Default value is 15_000.","ref":"Finch.html#request/6","title":"Finch.request/6","type":"function"},{"doc":"Start an instance of Finch. Options: :name - The name of your Finch instance. This field is required. :pools - A map specifying the configuration for your pools. The keys should be URLs provided as binaries, or the atom :default to provide a catch-all configuration to be used for any unspecified URLs. See &quot;Pool Configuration Options&quot; below for details on the possible map values. Default value is %{default: [size: 10, count: 1]}. Pool Configuration Options :size - Number of connections to maintain in each pool. The default value is 10. :count - Number of pools to start. The default value is 1. :conn_opts - These options are passed to Mint.HTTP.connect/4 whenever a new connection is established. :mode is not configurable as Finch must control this setting. Typically these options are used to configure proxying, https settings, or connect timeouts. The default value is [].","ref":"Finch.html#start_link/1","title":"Finch.start_link/1","type":"function"},{"doc":"A body associated with a request.","ref":"Finch.html#t:body/0","title":"Finch.body/0","type":"type"},{"doc":"An HTTP request method represented as an atom() or a String.t(). The following atom methods are supported: :get, :post, :put, :patch, :delete, :head, :options. You can use any arbitrary method by providing it as a String.t().","ref":"Finch.html#t:http_method/0","title":"Finch.http_method/0","type":"type"},{"doc":"The :name provided to Finch in start_link/1.","ref":"Finch.html#t:name/0","title":"Finch.name/0","type":"type"},{"doc":"A Uniform Resource Locator, the address of a resource on the Web.","ref":"Finch.html#t:url/0","title":"Finch.url/0","type":"type"},{"doc":"A response to a request.","ref":"Finch.Response.html","title":"Finch.Response","type":"module"},{"doc":"A body associated with a response.","ref":"Finch.Response.html#t:body/0","title":"Finch.Response.body/0","type":"type"},{"doc":"","ref":"Finch.Response.html#t:t/0","title":"Finch.Response.t/0","type":"type"},{"doc":"Telemetry integration. Unless specified, all time&#39;s are in :native units. Finch executes the following events: [:finch, :queue, :start] - Executed before checking out a connection from the pool. Measurements :system_time - The system time Metadata: :pool - The pool&#39;s pid :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. [:finch, :queue, :stop] - Executed after a connection is retrieved from the pool. Measurements :duration - Duration to check out a pool connection. :idle_time - Elapsed time since the connection was last checked in or initialized. Metadata :pool - The pool&#39;s pid :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. [:finch, :queue, :exception] - Executed if checking out a connection throws an exception. Measurements :duration - The time it took before raising an exception Metadata :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. :kind - The type of exception. :error - Error description or error data. :stacktrace - The stacktrace [:finch, :connect, :start] - Executed before opening a new connection. If a connection is being re-used this event will not be executed. Measurements :system_time - The system time Metadata :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. [:finch, :connect, :stop] - Executed after a connection is opened. Measurements :duration - Duration to connect to the host. Metadata: :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. :error - This value is optional. It includes any errors that occured while opening the connection. [:finch, :request, :start] - Executed before sending a request. Measurements: :system_time - The system time Metadata: :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. :path - The request path. [:finch, :request, :stop] - Executed after a request is finished. Measurements: :duration - Duration to make the request. Metadata: :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. :path - The request path. :error - This value is optional. It includes any errors that occured while making the request. [:finch, :response, :start] - Executed before receiving the response. Measurements: :system_time - The system time Metadata: :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. :path - The request path. [:finch, :response, :stop] - Executed after a response has been fully received. Measurements: :duration - Duration to receive the response. Metadata: :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on. :path - The request path. :error - This value is optional. It includes any errors that occured while receiving the response. [:finch, :reused_connection] - Executed if an existing connection is reused. There are no measurements provided with this event. Metadata: :scheme - The scheme used in the connection. either http or https :host - The host address :port - the port to connect on.","ref":"Finch.Telemetry.html","title":"Finch.Telemetry","type":"module"}]